unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_CaiGouSQList, U_YarnList, U_ShaRKList, U_ShaOutList,
  U_ShaKCHZList, U_ShaKCList, U_ShaCLlist;


       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmCaiGouSQListLR, frmCaiGouSQListGQX, frmCaiGouSQListCX, frmCaiGouSQListCXCJ: TfrmCaiGouSQList;
  frmShaRKListRK, frmShaRKListGQX, frmShaRKListView: TfrmShaRKList;
  frmShaOutListCK, frmShaOutListGQX, frmShaOutListView: TfrmShaOutList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if Trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
//  server := '.';
    dtbase := 'chenfengdata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;

  end
  else
    DConString := DataBaseStr;
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;
                                     

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    1:  //纱线日报表
      begin
        if frmSXLIST = nil then
        begin
          frmSXLIST := TfrmSXLIST.Create(application.MainForm);
          with frmSXLIST do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSXLIST.BringToFront;
       //句柄
        mnewHandle := frmSXLIST.Handle;
      end;
    -10:  //纱线档案
      begin
        if frmYarnList = nil then
        begin
          frmYarnList := TfrmYarnList.Create(application.MainForm);
          with frmYarnList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYarnList.BringToFront;
       //句柄
        mnewHandle := frmYarnList.Handle;
      end;

    -901:  //纱线采购加工申请录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线采购加工申请录入' then
          begin
            BringWindowToTop(frmCaiGouSQListLR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCaiGouSQListLR := TfrmCaiGouSQList.Create(application.MainForm);
          with frmCaiGouSQListLR do
          begin
            Title := '纱线采购加工申请录入';
            canshu1 := '录入';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCaiGouSQListLR.BringToFront;
       //句柄
        mnewHandle := frmCaiGouSQListLR.Handle;
      end;
    -902:  //纱线采购加工申请高权限
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线采购加工申请高权限' then
          begin
            BringWindowToTop(frmCaiGouSQListGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCaiGouSQListGQX := TfrmCaiGouSQList.Create(application.MainForm);
          with frmCaiGouSQListGQX do
          begin
            Title := '纱线采购加工申请高权限';
            canshu1 := '高权限';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCaiGouSQListGQX.BringToFront;
       //句柄
        mnewHandle := frmCaiGouSQListGQX.Handle;
      end;
    -903:  //纱线采购加工申请查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线采购加工申请查询' then
          begin
            BringWindowToTop(frmCaiGouSQListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCaiGouSQListCX := TfrmCaiGouSQList.Create(application.MainForm);
          with frmCaiGouSQListCX do
          begin
            Title := '纱线采购加工申请查询';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCaiGouSQListCX.BringToFront;
       //句柄
        mnewHandle := frmCaiGouSQListCX.Handle;
      end;
    -1:  //纱线入库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线入库管理' then
          begin
            BringWindowToTop(frmShaRKListRK.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShaRKListRK := TfrmShaRKList.Create(application.MainForm);
          with frmShaRKListRK do
          begin
            Title := '纱线入库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListRK.BringToFront;
       //句柄
        mnewHandle := frmShaRKListRK.Handle;
      end;
    -101:  //纱线入库管理(高权限)
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线入库管理(高权限)' then
          begin
            BringWindowToTop(frmShaRKListGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListGQX := TfrmShaRKList.Create(application.MainForm);
          with frmShaRKListGQX do
          begin
            Title := '纱线入库管理(高权限)';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListGQX.BringToFront;
       //句柄
        mnewHandle := frmShaRKListGQX.Handle;
      end;
    -102:  //纱线入库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线入库查询' then
          begin
            BringWindowToTop(frmShaRKListView.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListView := TfrmShaRKList.Create(application.MainForm);
          with frmShaRKListView do
          begin
            Title := '纱线入库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListView.BringToFront;
       //句柄
        mnewHandle := frmShaRKListView.Handle;
      end;
    -2:  //纱线出库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线出库管理' then
          begin
            BringWindowToTop(frmShaOutListCK.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListCK := TfrmShaOutList.Create(application.MainForm);
          with frmShaOutListCK do
          begin
            Title := '纱线出库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListCK.BringToFront;
       //句柄
        mnewHandle := frmShaOutListCK.Handle;
      end;
    -201:  //纱线出库管理(高权限)
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线出库管理(高权限)' then
          begin
            BringWindowToTop(frmShaOutListGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListGQX := TfrmShaOutList.Create(application.MainForm);
          with frmShaOutListGQX do
          begin
            Title := '纱线出库管理(高权限)';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListGQX.BringToFront;
       //句柄
        mnewHandle := frmShaOutListGQX.Handle;
      end;
    -202:  //纱线出库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线出库查询' then
          begin
            BringWindowToTop(frmShaOutListView.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListView := TfrmShaOutList.Create(application.MainForm);
          with frmShaOutListView do
          begin
            Title := '纱线出库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListView.BringToFront;
       //句柄
        mnewHandle := frmShaOutListView.Handle;
      end;
    -3:  //纱线库存
      begin
        if frmShaKCList = nil then
        begin
          frmShaKCList := TfrmShaKCList.Create(application.MainForm);
          with frmShaKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaKCList.BringToFront;
       //句柄
        mnewHandle := frmShaKCList.Handle;
      end;

    -6:  //纱线库存汇总查询
      begin
        if frmShaKCHZList = nil then
        begin
          frmShaKCHZList := TfrmShaKCHZList.Create(application.MainForm);
          with frmShaKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaKCHZList.BringToFront;
       //句柄
        mnewHandle := frmShaKCHZList.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Yarn) then
    DataLink_Yarn := TDataLink_Yarn.Create(Application);
  try
    with DataLink_Yarn.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_Yarn.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_Yarn.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

